
Redmine - Defect #5803

Precedes/Follows Relationships Broke

2010-07-01 21:33 - Howard Mall

Status: Closed Start date: 2010-07-01

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 1.0.3   

Resolution: Fixed Affected version:  

Description

The latest stable release (0.9.5) 'precedes' and 'follows' relationships no longer effect 'Start' and 'Due date's for issues. For example

if I change the 'Due date' for 'Task 1.1' which 'precedes' 'Task 1.2', the 'Start' for Task 1.2 should shift accordingly. It no longer does

this.

I checked out the 0.9.0 release and those dependencies work as advertised.

Felix Schäfer confirmed this on r3813 as a regression of Feature #279 but asked that I file a Defect.

Perhaps this is related to the sub-issue logic?

Redmine is proving very useful and we are eagerly awaiting the 1.0.0 release candidate on July 3, 2010. I'm hoping this defect can

be resolved before that release, because it is a really superb feature in 0.9.0.

MySQL 5.0.90-community-nt

Ruby 1.8.7 (2008-08-11 patchlevel 72)

Rails 2.3.5

0.9.5 but also r3813

Related issues:

Related to Redmine - Feature #4590: Precede-Follow relation should move follo... Closed 2010-01-15

Related to Redmine - Defect #5398: Can not reschedule the start date of follo... New 2010-04-29

Associated revisions

Revision 4263 - 2010-10-19 21:16 - Jean-Philippe Lang

Fixed: precedes/follows relations no longer update start/due dates (#5803).

History

#1 - 2010-07-02 21:34 - Howard Mall

- Assignee set to Jean-Philippe Lang

#2 - 2010-07-05 11:33 - Yuki Kita

- File issue.rb.diff added

- Assignee deleted (Jean-Philippe Lang)

Confirmed.

Here is the patch.

The defect is due to the timing of the saving a issue.

#3 - 2010-07-06 23:06 - Howard Mall

Looking at the code, it does not appear to recurse through the 'follows' relationships.  For example, we have three issues (Task 1.1, Task 1.2, and

Task 1.3) that all follow each other sequentially.  Task 1.1 changes its end date.  Task 1.2 shifts, but Task 1.3 stays the same.

#4 - 2010-07-06 23:06 - Howard Mall

Looking at the code, it does not appear to recurse through the 'follows' relationships.  For example, we have three issues (Task 1.1, Task 1.2, and

Task 1.3) that all follow each other sequentially.  Task 1.1 changes its end date.  Task 1.2 shifts, but Task 1.3 stays the same.
#5 - 2010-07-12 16:36 - Howard Mall

I'm pretty certain of my fix, but I'm still trying to figure out how to make a proper diff file to attach.  However, I basically (in app/model/issue.rb) put

the :reschedule_following_issues to occur after_save and added a call to issue_to.reschedule_following issues to app/models/issue_relation.rb in

the set_issue_to_dates function.  This required that I also make reschedule_following_issues a public function.

#6 - 2010-08-11 02:54 - John Davis

I can confirm that this is a problem with 1.0.0 (RC) (2010-07-18).  Anybody know when it might be fixed?

#7 - 2010-08-11 04:52 - Jean-Baptiste Barth

When it has tests : we don't want it to be broken again in a next release. I may have a look at it if I have the time.

#8 - 2010-10-19 21:11 - Jean-Philippe Lang

- Status changed from New to Resolved

- Target version set to 1.0.3

- Resolution set to Fixed

Fix and test committed in r4263.

#9 - 2010-11-01 01:22 - Eric Davis

- Status changed from Resolved to Closed

Merged into 1.0-stable for release in 1.0.3

#10 - 2011-02-07 19:59 - JiuG Neiva

- File Redmine_issue_5803.pdf added

Jean-Philippe Lang wrote:

Fix and test committed in r4263.

 The relationship is still broken, at lest in version 1.1

It works fine when you change the due date of the preceding task to a later date, but does not work when changed to a previous date.

Please take a look at the attached pdf for more details.

Thanks!

#11 - 2011-02-07 20:26 - JiuG Neiva

JiuG Neiva wrote:

Jean-Philippe Lang wrote:

Fix and test committed in r4263.

 The relationship is still broken, at lest in version 1.1

It works fine when you change the due date of the preceding task to a later date, but does not work when changed to a previous date.

Please take a look at the attached pdf for more details.

Thanks!

 I can confirm that in version 1.1.1 the problem is still present

Thanks

#12 - 2011-02-08 06:00 - JiuG Neiva

I found these other related issues:

Feature #4590: Precede-Follow relation moves backward

Defect #5398: Can not reschedule the start date of following issues at once

2025-08-23 2/4

https://www.redmine.org/projects/redmine/repository/svn/revisions/4263
https://www.redmine.org/projects/redmine/repository/svn/revisions/4263
https://www.redmine.org/projects/redmine/repository/svn/revisions/4263
https://www.redmine.org/issues/4590
https://www.redmine.org/issues/5398


#13 - 2011-02-08 06:33 - JiuG Neiva

JiuG Neiva wrote:

I found these other related issues:

Feature #4590: Precede-Follow relation moves backward

Defect #5398: Can not reschedule the start date of following issues at once

 Finally, I found that tengel liu is right in #4590.

The problem, at least in version 1.1 and 1.1.1 is at line 498

Original: if start_date.nil? || start_date < date

Should be: if start_date.nil? || start_date != date

Would be nice to include this in future releases.

Thank you

#14 - 2011-02-18 12:25 - Fernando Hartmann

It's happening in my installation too !

I have a lot of issues whit relationships and is almost impossible to me to correct the dates by hand !

Please correct this problem as fast as you can !

Thanks for the great job.

#15 - 2011-08-19 18:10 - Aurélien Appéré

Still have the problem as described in #4590 with version 1.2.1 stable.

#16 - 2012-11-22 16:25 - evandro bubiak

still occurs on version 2.x

#17 - 2012-11-22 17:00 - Daniel Felix

evandro bubiak wrote:

still occurs on version 2.x

 I can confirm this with the current trunk (r10864).

JiuG Neiva wrote:

It works fine when you change the due date of the preceding task to a later date, but does not work when changed to a previous date.

 This still seems to apply. Changes which sets the due date to an earlier date are ignored, only changes which postpone the due date apply on the

process chain.

Well maybe this would work as aspected, if you won't prefer the following tickets. But if you want to prefer all following tickets as configured, all other

posts must follow the new duedate.

Maybe this could be made by some option "reorganize following..." or something like that?

#18 - 2012-11-23 10:37 - Sebastian Hucke

I can confirm that behavior for our productive redmine system (version 2.0.3).

I think that this is an intended feature. The buffer is implemented like it should be: as a minimum amount of time between two tickets.

jp jp: Am i right? In this case, I would open a feature request for the solution proposed by Daniel Felix. Hopefully, rescheduling will be much better

with version 2.2.0, but still not perfect without an option to reschedule automatically to both earlier and later dates.

Daniel Lopez Felix: +1 for your reorganization option.

#19 - 2012-11-24 14:46 - Jean-Philippe Lang

This was the intended behaviour, but #4590 is now implemented for 2.2.0. Following issues are now rescheduled in both directions.

Files
issue.rb.diff 1.11 KB 2010-07-05 Yuki Kita

Redmine_issue_5803.pdf 206 KB 2011-02-07 JiuG Neiva
